package com.hzya.frame.grpU8.nxproof.oerannex.service;
/*
* @Description 附件关系表
* @Author xiangerlin 
  @Date 2022-10-26 10:06
*/


import com.hzya.frame.grpU8.nxproof.oerannex.entity.OerAnnexEntity;

import java.util.List;

public interface IOerAnnexService {

    /**
     * 查询附件关系
     * @param entity
     * @return
     * @throws Exception
     */
    List<OerAnnexEntity> queryAnnex(OerAnnexEntity entity)throws Exception;
    /**
     * 查询最大id
     * @param entity
     * @return
     * @throws Exception
     */
    String queryMaxId(OerAnnexEntity entity)throws Exception;

    /**
     * 保存附件关系
     * @param entity
     * @throws Exception
     */
    void saveAnnex(OerAnnexEntity entity)throws Exception;

    /**
     * 删除附件关系
     * @param entity
     * @throws Exception
     */
    void deleteAnnex(OerAnnexEntity entity)throws Exception;

    /**
     * 查询附件关系，联查附件对象表
     * @param mlid
     * @return
     * @throws Exception
     */
    List<OerAnnexEntity> queryAnnexAndFile(String mlid)throws Exception;
}
